/*! Seppiko SableCSS Common | MIT License | https://sablecss.seppiko.org */
@use "../sable";

%font-medium {
  @include sable.typo-font-weight(500);
}

%font-bold {
  @include sable.typo-font-weight(700);
}

// 1. Remove <h1>`-`<h6>` margins from headings.
%hl-heading {
  @include sable.spac-margin-none(); // 1
  @include sable.typo-line-height(1.5);
}
%hs-heading {
  @include sable.spac-margin-none(); // 1
  @include sable.typo-line-height(1.25);
}

$h1-font-size: 2.75rem !default;
$h2-font-size: 2.5rem !default;
$h3-font-size: 2.25rem !default;
$h4-font-size: 2rem !default;
$h5-font-size: 1.75rem !default;
$h6-font-size: 1.5rem !default;

a {
  @include sable.typo-text-decoration(none);
}

h1,
.h1 {
  @extend %hl-heading;
  @extend %font-bold;
  @include sable.typo-font-size($h1-font-size);
}

h2,
.h2 {
  @extend %hl-heading;
  @extend %font-bold;
  @include sable.typo-font-size($h2-font-size);
}

h3,
.h3 {
  @extend %hl-heading;
  @extend %font-bold;
  @include sable.typo-font-size($h3-font-size);
}

h4,
.h4 {
  @extend %hs-heading;
  @extend %font-medium;
  @include sable.typo-font-size($h4-font-size);
}

h5,
.h5 {
  @extend %hs-heading;
  @extend %font-medium;
  @include sable.typo-font-size($h5-font-size);
}

h6,
.h6 {
  @extend %hs-heading;
  @include sable.typo-font-size($h6-font-size);
}

hr {
  @include sable.typo-color();
  @include sable.typo-opacity(1);
  @include sable.spac-margin-none();
  @include sable.spac-padding-none();
}

ol, ul {
  @include sable.spac-margin-inline-none();
  @include sable.spac-margin-block-none();
  @include sable.spac-padding-inline-none();
}

main,
section,
article,
footer {
  @include sable.size-width(100%);
}

button {
  @include sable.layo-overflow(visible);
}

button,
[type="button"],
[type="reset"],
[type="submit"] {
  @include sable.inter-cursor(pointer);
}

blockquote,
figure,
p {
  @include sable.spac-margin-inline-none();
  @include sable.spac-margin-block-none();
}

blockquote,
figure {
  @include sable.spac-margin-bottom(.5rem);
}

p {
  @include sable.typo-line-height(1.15);
  @include sable.spac-margin-top(0);
  @include sable.spac-margin-bottom(1rem);

  &:last-child {
    @include sable.spac-margin-bottom(0);
  }
}

pre {
  @include sable.spac-margin-none();
  @include sable.typo-white-space(pre-wrap);
  @include sable.layo-overflow-with(wrap, break-word);
}

$footer-font-size: .875rem !default;
$footer-line-height: 1.15 !default;

footer {
  @include sable.typo-font-size($footer-font-size);
  @include sable.typo-line-height($footer-line-height);
}

table {
  @include sable.border-border-collapse(collapse);
  
  label, 
  input {
    @include sable.layo-display(table-cell);
  }

  caption {
    @include sable.typo-text-align(center);
    @include sable.typo-caption-side(bottom);
    @include sable.typo-font-size(.875rem);
  }
}

:focus-visible {
  @include sable.border-outline(none);
}
